//Legal Notice: (C)2007 Altera Corporation. All rights reserved.  Your
//use of Altera Corporation's design tools, logic functions and other
//software and tools, and its AMPP partner logic functions, and any
//output files any of the foregoing (including device programming or
//simulation files), and any associated documentation or information are
//expressly subject to the terms and conditions of the Altera Program
//License Subscription Agreement or other applicable license agreement,
//including, without limitation, that your use is for the sole purpose
//of programming logic devices manufactured by Altera and sold by Altera
//or its authorized distributors.  Please refer to the applicable
//agreement for further details.

// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

//vj_name => vj
//interface_widths => 1,6,20,8
//interface_opcodes => 
//do_signaltap => 0
//name => vj_rw
//interface_types => r,r,r,w
//interface_names => rdempty,rdusedw,readdata,outdata
module vj_rw_module (
                      // inputs:
                       rdempty,
                       rdusedw,
                       readdata,

                      // outputs:
                       ack_rdempty,
                       ack_rdusedw,
                       ack_readdata,
                       vj_clk
                    )
;

  output           ack_rdempty;
  output           ack_rdusedw;
  output           ack_readdata;
  output           vj_clk;
  input            rdempty;
  input   [  5: 0] rdusedw;
  input   [ 19: 0] readdata;

  wire             ack_rdempty;
  wire             ack_rdusedw;
  wire             ack_readdata;
  reg              bypass_reg;
  wire             cdr;
  wire             cir;
  wire             clk;
  wire             e1dr;
  wire             e2dr;
  wire    [  1: 0] ir_in;
  wire    [  1: 0] ir_out;
  wire             pdr;
  wire    [  5: 0] rdusedw_read_mask;
  reg     [  5: 0] rdusedw_read_reg;
  wire    [ 19: 0] readdata_read_mask;
  reg     [ 19: 0] readdata_read_reg;
  wire             sdr;
  wire             select_outdata;
  wire             select_rdempty;
  wire             select_rdusedw;
  wire             select_readdata;
  wire             tck;
  wire             tdi;
  wire             tdo;
  wire             udr;
  wire             uir;
  wire             vj_clk;
  assign vj_clk = tck;
  assign clk = tck;
  vj vj_inst
    (
      .ir_in (ir_in),
      .ir_out (ir_out),
      .tck (tck),
      .tdi (tdi),
      .tdo (tdo),
      .virtual_state_cdr (cdr),
      .virtual_state_cir (cir),
      .virtual_state_e1dr (e1dr),
      .virtual_state_e2dr (e2dr),
      .virtual_state_pdr (pdr),
      .virtual_state_sdr (sdr),
      .virtual_state_udr (udr),
      .virtual_state_uir (uir)
    );


  assign ir_out = 2'b00;
  always @(posedge clk)
    begin
      bypass_reg <= tdi;
    end


  assign select_rdempty = ir_in == 2'b00;
  assign select_rdusedw = ir_in == 2'b01;
  assign select_readdata = ir_in == 2'b10;

  assign ack_rdempty = e1dr & select_rdempty;
  always @(posedge clk)
    begin
      if (select_rdusedw & sdr)
          rdusedw_read_reg <= {rdusedw_read_mask[4 : 1],
                    rdusedw_read_mask[0],
                    ~(rdusedw_read_mask[5])};

    end


  assign rdusedw_read_mask = {rdusedw_read_reg[5 : 1],
    ~(rdusedw_read_reg[0])};

  assign ack_rdusedw = e1dr & select_rdusedw;
  always @(posedge clk)
    begin
      if (select_readdata & sdr)
          readdata_read_reg <= {readdata_read_mask[18 : 1],
                    readdata_read_mask[0],
                    ~(readdata_read_mask[19])};

    end


  assign readdata_read_mask = {readdata_read_reg[19 : 1],
    ~(readdata_read_reg[0])};

  assign ack_readdata = e1dr & select_readdata;
  assign tdo = (select_rdempty)? rdempty :
    (select_rdusedw)? (|(rdusedw_read_mask & rdusedw)) :
    (select_readdata)? (|(readdata_read_mask & readdata)) :
    bypass_reg;


endmodule



// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module vj_rw (
               // inputs:
                rdempty,
                rdusedw,
                readdata,

               // outputs:
                ack_rdempty,
                ack_rdusedw,
                ack_readdata,
                vj_clk
             )
;

  output           ack_rdempty;
  output           ack_rdusedw;
  output           ack_readdata;
  output           vj_clk;
  input            rdempty;
  input   [  5: 0] rdusedw;
  input   [ 19: 0] readdata;

  wire             ack_rdempty;
  wire             ack_rdusedw;
  wire             ack_readdata;
  wire             vj_clk;
  vj_rw_module the_vj_rw_module
    (
      .ack_rdempty  (ack_rdempty),
      .ack_rdusedw  (ack_rdusedw),
      .ack_readdata (ack_readdata),
      .rdempty      (rdempty),
      .rdusedw      (rdusedw),
      .readdata     (readdata),
      .vj_clk       (vj_clk)
    );


endmodule

